org.icefaces.ace.component.list

## Class ListBase

- java.lang.Object
- - javax.faces.component.UIComponent
  - - javax.faces.component.UIComponentBase
    - - javax.faces.component.UIData
      - - javax.faces.component.html.HtmlDataTable
        - - org.icefaces.impl.component.UISeriesBase
          - - org.icefaces.ace.component.list.ListBase

- All Implemented Interfaces:
    java.util.EventListener, javax.faces.component.behavior.ClientBehaviorHolder, javax.faces.component.NamingContainer, javax.faces.component.PartialStateHolder, javax.faces.component.StateHolder, javax.faces.component.TransientStateHolder, javax.faces.component.UniqueIdVendor, javax.faces.event.ComponentSystemEventListener, javax.faces.event.FacesListener, javax.faces.event.SystemEventListenerHolder, IceClientBehaviorHolder, IList, org.icefaces.impl.component.SeriesStateHolder
  Direct Known Subclasses:
    ACEList

      public abstract class ListBase
      extends org.icefaces.impl.component.UISeriesBase
      implements IList, IceClientBehaviorHolder

  Renders an Array or List of objects as a styled HTML UL element. Supports dual & multilist configurations, reordering, item drag/drop, selection & block style layout. The component strives to be exceptionally easy to style and adjust layout.The ace:list value attributemay take a List of SelectItem objects to use their String label representations as list item contents, can take SelectItems as a model via f:selectItem(s) children, or value defines a List of arbitrary objects to be represented by iterative renderings of our child components.The components are associated with the iterative object via bindings of the 'var' property.

  For more information, see the List Wiki Documentation.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `ListBase.PropertyKeys`

    - ### Nested classes/interfaces inherited from class org.icefaces.impl.component.UISeriesBase

      `org.icefaces.impl.component.UISeriesBase.RowEvent`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `COMPONENT_TYPE`
    `static java.lang.String` | `RENDERER_TYPE`

    - ### Fields inherited from class org.icefaces.impl.component.UISeriesBase

      `dataModel, savedChildren, savedSeriesState`

    - ### Fields inherited from class javax.faces.component.UIData

      `COMPONENT_FAMILY`

    - ### Fields inherited from class javax.faces.component.UIComponent

      `ATTRS_WITH_DECLARED_DEFAULT_VALUES, BEANINFO_KEY, bindings, COMPOSITE_COMPONENT_TYPE_KEY, COMPOSITE_FACET_NAME, CURRENT_COMPONENT, CURRENT_COMPOSITE_COMPONENT, FACETS_KEY, HONOR_CURRENT_COMPONENT_ATTRIBUTES_PARAM_NAME, VIEW_LOCATION_KEY`

    - ### Fields inherited from interface javax.faces.component.NamingContainer

      `SEPARATOR_CHAR`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ListBase()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addClientBehavior(java.lang.String eventName, javax.faces.component.behavior.ClientBehavior behavior)`
    `java.lang.String` | `getAccesskey()` Return the value of the `accesskey` property.
    `java.lang.String` | `getBodyClass()` Return the value of the `bodyClass` property.
    `java.lang.String` | `getBodyStyle()` Return the value of the `bodyStyle` property.
    `java.lang.String` | `getBottomButtonClass()` Return the value of the `bottomButtonClass` property.
    `java.lang.String` | `getControlsContainerClass()` Return the value of the `controlsContainerClass` property.
    `java.lang.String` | `getControlsFormat()` Return the value of the `controlsFormat` property.
    `java.lang.String` | `getControlsItemClass()` Return the value of the `controlsItemClass` property.
    `java.lang.String` | `getControlsSpacerClass()` Return the value of the `controlsSpacerClass` property.
    `java.lang.String` | `getDefaultEventName()`
    `java.lang.String` | `getDefaultExecute(java.lang.String event)`
    `java.lang.String` | `getDefaultRender(java.lang.String event)`
    `java.lang.String` | `getDownButtonClass()` Return the value of the `downButtonClass` property.
    `java.lang.String` | `getDropGroup()` Return the value of the `dropGroup` property.
    `java.util.Collection<java.lang.String>` | `getEventNames()`
    `java.lang.String` | `getFamily()`
    `java.lang.Object` | `getFilterBy()` Return the value of the `filterBy` property.
    `java.util.List` | `getFilteredData()` Return the value of the `filteredData` property.
    `java.lang.String` | `getFilterEvent()` Return the value of the `filterEvent` property.
    `javax.faces.component.UIComponent` | `getFilterFacet()` Return the value of the `filter facet` property.
    `java.lang.String` | `getFilterMatchMode()` Return the value of the `filterMatchMode` property.
    `java.lang.Object` | `getFilterOptions()` Return the value of the `filterOptions` property.
    `java.lang.String` | `getFilterStyle()` Return the value of the `filterStyle` property.
    `java.lang.String` | `getFilterStyleClass()` Return the value of the `filterStyleClass` property.
    `java.lang.String` | `getFilterValue()` Return the value of the `filterValue` property.
    `java.lang.Object` | `getFilterValues()` Return the value of the `filterValues` property.
    `java.lang.String` | `getFooterClass()` Return the value of the `footerClass` property.
    `javax.faces.component.UIComponent` | `getFooterFacet()` Return the value of the `footer facet` property.
    `java.lang.String` | `getFooterStyle()` Return the value of the `footerStyle` property.
    `java.lang.String` | `getHeaderClass()` Return the value of the `headerClass` property.
    `javax.faces.component.UIComponent` | `getHeaderFacet()` Return the value of the `header facet` property.
    `java.lang.String` | `getHeaderStyle()` Return the value of the `headerStyle` property.
    `java.lang.String` | `getHeight()` Return the value of the `height` property.
    `java.lang.String` | `getItemClass()` Return the value of the `itemClass` property.
    `java.lang.String` | `getItemStyle()` Return the value of the `itemStyle` property.
    `java.lang.String` | `getListenerArgument(java.lang.String event)`
    `java.lang.String` | `getPlaceholderClass()` Return the value of the `placeholderClass` property.
    `javax.el.MethodExpression` | `getSelectionListener()` Return the value of the `selectionListener` property.
    `java.lang.String` | `getSelectionMode()` Return the value of the `selectionMode` property.
    `java.util.Set` | `getSelections()` Return the value of the `selections` property.
    `java.lang.Object` | `getSortBy()` Return the value of the `sortBy` property.
    `java.util.Comparator` | `getSortFunction()` Return the value of the `sortFunction` property.
    `java.lang.String` | `getStyle()` Return the value of the `style` property.
    `java.lang.String` | `getStyleClass()` Return the value of the `styleClass` property.
    `java.lang.Integer` | `getTabIndex()` Return the value of the `tabIndex` property.
    `java.lang.String` | `getTopButtonClass()` Return the value of the `topButtonClass` property.
    `java.lang.String` | `getUpButtonClass()` Return the value of the `upButtonClass` property.
    `java.lang.Integer` | `getValueHashCode()` Return the value of the `valueHashCode` property.
    `java.lang.Boolean` | `isApplyingFilters()` Return the value of the `applyingFilters` property.
    `java.lang.Boolean` | `isApplyingSorts()` Return the value of the `applyingSorts` property.
    `java.lang.Boolean` | `isCompact()` Return the value of the `compact` property.
    `java.lang.Boolean` | `isControlsEnabled()` Return the value of the `controlsEnabled` property.
    `java.lang.Boolean` | `isDoubleClickMigration()` Return the value of the `doubleClickMigration` property.
    `java.lang.Boolean` | `isDragging()` Return the value of the `dragging` property.
    `java.lang.Boolean` | `isPlaceholder()` Return the value of the `placeholder` property.
    `protected boolean` | `isPropertySet(java.lang.String finder)`
    `java.lang.Boolean` | `isSortAscending()` Return the value of the `sortAscending` property.
    `void` | `setAccesskey(java.lang.String accesskey)` Set the value of the `accesskey` property.
    `void` | `setApplyingFilters(java.lang.Boolean applyingFilters)` Set the value of the `applyingFilters` property.
    `void` | `setApplyingSorts(java.lang.Boolean applyingSorts)` Set the value of the `applyingSorts` property.
    `void` | `setBodyClass(java.lang.String bodyClass)` Set the value of the `bodyClass` property.
    `void` | `setBodyStyle(java.lang.String bodyStyle)` Set the value of the `bodyStyle` property.
    `void` | `setBottomButtonClass(java.lang.String bottomButtonClass)` Set the value of the `bottomButtonClass` property.
    `void` | `setCompact(java.lang.Boolean compact)` Set the value of the `compact` property.
    `void` | `setControlsContainerClass(java.lang.String controlsContainerClass)` Set the value of the `controlsContainerClass` property.
    `void` | `setControlsEnabled(java.lang.Boolean controlsEnabled)` Set the value of the `controlsEnabled` property.
    `void` | `setControlsFormat(java.lang.String controlsFormat)` Set the value of the `controlsFormat` property.
    `void` | `setControlsItemClass(java.lang.String controlsItemClass)` Set the value of the `controlsItemClass` property.
    `void` | `setControlsSpacerClass(java.lang.String controlsSpacerClass)` Set the value of the `controlsSpacerClass` property.
    `void` | `setDoubleClickMigration(java.lang.Boolean doubleClickMigration)` Set the value of the `doubleClickMigration` property.
    `void` | `setDownButtonClass(java.lang.String downButtonClass)` Set the value of the `downButtonClass` property.
    `void` | `setDragging(java.lang.Boolean dragging)` Set the value of the `dragging` property.
    `void` | `setDropGroup(java.lang.String dropGroup)` Set the value of the `dropGroup` property.
    `void` | `setFilterBy(java.lang.Object filterBy)` Set the value of the `filterBy` property.
    `void` | `setFilteredData(java.util.List filteredData)` Set the value of the `filteredData` property.
    `void` | `setFilterEvent(java.lang.String filterEvent)` Set the value of the `filterEvent` property.
    `void` | `setFilterFacet(javax.faces.component.UIComponent filter)` Set the value of the `filter facet` property.
    `void` | `setFilterMatchMode(java.lang.String filterMatchMode)` Set the value of the `filterMatchMode` property.
    `void` | `setFilterOptions(java.lang.Object filterOptions)` Set the value of the `filterOptions` property.
    `void` | `setFilterStyle(java.lang.String filterStyle)` Set the value of the `filterStyle` property.
    `void` | `setFilterStyleClass(java.lang.String filterStyleClass)` Set the value of the `filterStyleClass` property.
    `void` | `setFilterValue(java.lang.String filterValue)` Set the value of the `filterValue` property.
    `void` | `setFilterValues(java.lang.Object filterValues)` Set the value of the `filterValues` property.
    `void` | `setFooterClass(java.lang.String footerClass)` Set the value of the `footerClass` property.
    `void` | `setFooterFacet(javax.faces.component.UIComponent footer)` Set the value of the `footer facet` property.
    `void` | `setFooterStyle(java.lang.String footerStyle)` Set the value of the `footerStyle` property.
    `void` | `setHeaderClass(java.lang.String headerClass)` Set the value of the `headerClass` property.
    `void` | `setHeaderFacet(javax.faces.component.UIComponent header)` Set the value of the `header facet` property.
    `void` | `setHeaderStyle(java.lang.String headerStyle)` Set the value of the `headerStyle` property.
    `void` | `setHeight(java.lang.String height)` Set the value of the `height` property.
    `void` | `setItemClass(java.lang.String itemClass)` Set the value of the `itemClass` property.
    `void` | `setItemStyle(java.lang.String itemStyle)` Set the value of the `itemStyle` property.
    `void` | `setPlaceholder(java.lang.Boolean placeholder)` Set the value of the `placeholder` property.
    `void` | `setPlaceholderClass(java.lang.String placeholderClass)` Set the value of the `placeholderClass` property.
    `void` | `setSelectionListener(javax.el.MethodExpression selectionListener)` Set the value of the `selectionListener` property.
    `void` | `setSelectionMode(java.lang.String selectionMode)` Set the value of the `selectionMode` property.
    `void` | `setSelections(java.util.Set selections)` Set the value of the `selections` property.
    `void` | `setSortAscending(java.lang.Boolean sortAscending)` Set the value of the `sortAscending` property.
    `void` | `setSortBy(java.lang.Object sortBy)` Set the value of the `sortBy` property.
    `void` | `setSortFunction(java.util.Comparator sortFunction)` Set the value of the `sortFunction` property.
    `void` | `setStyle(java.lang.String style)` Set the value of the `style` property.
    `void` | `setStyleClass(java.lang.String styleClass)` Set the value of the `styleClass` property.
    `void` | `setTabIndex(java.lang.Integer tabIndex)` Set the value of the `tabIndex` property.
    `void` | `setTopButtonClass(java.lang.String topButtonClass)` Set the value of the `topButtonClass` property.
    `void` | `setUpButtonClass(java.lang.String upButtonClass)` Set the value of the `upButtonClass` property.
    `void` | `setValueExpression(java.lang.String name, javax.el.ValueExpression binding)`
    `void` | `setValueHashCode(java.lang.Integer valueHashCode)` Set the value of the `valueHashCode` property.

    - ### Methods inherited from class org.icefaces.impl.component.UISeriesBase

      `broadcast, encodeBegin, ensureFirstRowInRange, getClientId, getContainerClientId, getDataModel, getRowCount, getRowData, getRowIndex, getSavedChildren, getSavedSeriesState, getVar, getVarStatus, isRowAvailable, iterate, processDecodes, processUpdates, processValidators, queueEvent, restoreChild, restoreChildrenState, restoreChildState, restoreSeriesState, restoreState, saveChild, saveChildrenState, saveChildState, saveSeriesState, saveState, setDataModel, setId, setRowIndex, setValue, setValueBinding, setVar, setVarStatus, synchWithPaginator, visitTree, wrapDataModel`

    - ### Methods inherited from class javax.faces.component.html.HtmlDataTable

      `getBgcolor, getBodyrows, getBorder, getCaptionClass, getCaptionStyle, getCellpadding, getCellspacing, getColumnClasses, getDir, getFrame, getLang, getOnclick, getOndblclick, getOnkeydown, getOnkeypress, getOnkeyup, getOnmousedown, getOnmousemove, getOnmouseout, getOnmouseover, getOnmouseup, getRowClasses, getRules, getSummary, getTitle, getWidth, setBgcolor, setBodyrows, setBorder, setCaptionClass, setCaptionStyle, setCellpadding, setCellspacing, setColumnClasses, setDir, setFrame, setLang, setOnclick, setOndblclick, setOnkeydown, setOnkeypress, setOnkeyup, setOnmousedown, setOnmousemove, setOnmouseout, setOnmouseover, setOnmouseup, setRowClasses, setRules, setSummary, setTitle, setWidth`

    - ### Methods inherited from class javax.faces.component.UIData

      `createUniqueId, getFirst, getFooter, getHeader, getRows, getValue, invokeOnComponent, isRowStatePreserved, markInitialState, setFirst, setFooter, setHeader, setRows, setRowStatePreserved`

    - ### Methods inherited from class javax.faces.component.UIComponentBase

      `addFacesListener, clearInitialState, decode, encodeChildren, encodeEnd, findComponent, getAttributes, getChildCount, getChildren, getClientBehaviors, getFacesContext, getFacesListeners, getFacet, getFacetCount, getFacets, getFacetsAndChildren, getId, getListenersForEventClass, getParent, getRenderer, getRendererType, getRendersChildren, getValueBinding, isRendered, isTransient, processRestoreState, processSaveState, removeFacesListener, restoreAttachedState, saveAttachedState, setParent, setRendered, setRendererType, setTransient, subscribeToEvent, unsubscribeFromEvent`

    - ### Methods inherited from class javax.faces.component.UIComponent

      `encodeAll, getClientId, getCompositeComponentParent, getCurrentComponent, getCurrentCompositeComponent, getNamingContainer, getResourceBundleMap, getStateHelper, getStateHelper, getTransientStateHelper, getTransientStateHelper, getValueExpression, initialStateMarked, isCompositeComponent, isInView, isVisitable, popComponentFromEL, processEvent, pushComponentToEL, restoreTransientState, saveTransientState, setInView`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javax.faces.component.behavior.ClientBehaviorHolder

      `getClientBehaviors`

- - ### Field Detail

    - #### COMPONENT_TYPE

          public static final java.lang.String COMPONENT_TYPE

      See Also:
        Constant Field Values

    - #### RENDERER_TYPE

          public static final java.lang.String RENDERER_TYPE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ListBase

          public ListBase()

  - ### Method Detail

    - #### getFamily

          public java.lang.String getFamily()

      Overrides:
        `getFamily` in class `javax.faces.component.UIData`

    - #### setAccesskey

          public void setAccesskey(java.lang.String accesskey)

      Set the value of the `accesskey` property.

      Contents: Access key that, when pressed, transfers focus to this component.

      Specified by:
        `setAccesskey` in interface `IList`

    - #### getAccesskey

          public java.lang.String getAccesskey()

      Return the value of the `accesskey` property.

      Contents: Access key that, when pressed, transfers focus to this component.

      Specified by:
        `getAccesskey` in interface `IList`

    - #### setBodyClass

          public void setBodyClass(java.lang.String bodyClass)

      Set the value of the `bodyClass` property.

      Contents: Style class to apply to the container UL element.

      Specified by:
        `setBodyClass` in interface `IList`

    - #### getBodyClass

          public java.lang.String getBodyClass()

      Return the value of the `bodyClass` property.

      Contents: Style class to apply to the container UL element.

      Specified by:
        `getBodyClass` in interface `IList`

    - #### setBodyStyle

          public void setBodyStyle(java.lang.String bodyStyle)

      Set the value of the `bodyStyle` property.

      Contents: Style rules to apply to the container UL element.

      Specified by:
        `setBodyStyle` in interface `IList`

    - #### getBodyStyle

          public java.lang.String getBodyStyle()

      Return the value of the `bodyStyle` property.

      Contents: Style rules to apply to the container UL element.

      Specified by:
        `getBodyStyle` in interface `IList`

    - #### setBottomButtonClass

          public void setBottomButtonClass(java.lang.String bottomButtonClass)

      Set the value of the `bottomButtonClass` property.

      Contents: Style class to apply to the span defining the bottom button icon.

      Specified by:
        `setBottomButtonClass` in interface `IList`

    - #### getBottomButtonClass

          public java.lang.String getBottomButtonClass()

      Return the value of the `bottomButtonClass` property.

      Contents: Style class to apply to the span defining the bottom button icon. Default = 'ui-icon ui-icon-arrowstop-1-s'.

      Specified by:
        `getBottomButtonClass` in interface `IList`

    - #### setCompact

          public void setCompact(java.lang.Boolean compact)

      Set the value of the `compact` property.

      Contents: Enables an alternate style on the table that uses greatly reduced padding and a 8 point default font.

      Specified by:
        `setCompact` in interface `IList`

    - #### isCompact

          public java.lang.Boolean isCompact()

      Return the value of the `compact` property.

      Contents: Enables an alternate style on the table that uses greatly reduced padding and a 8 point default font. Default = 'false'.

      Specified by:
        `isCompact` in interface `IList`

    - #### setControlsContainerClass

          public void setControlsContainerClass(java.lang.String controlsContainerClass)

      Set the value of the `controlsContainerClass` property.

      Contents: Style class to apply to the DIV surrounding the reordering controls.

      Specified by:
        `setControlsContainerClass` in interface `IList`

    - #### getControlsContainerClass

          public java.lang.String getControlsContainerClass()

      Return the value of the `controlsContainerClass` property.

      Contents: Style class to apply to the DIV surrounding the reordering controls.

      Specified by:
        `getControlsContainerClass` in interface `IList`

    - #### setControlsEnabled

          public void setControlsEnabled(java.lang.Boolean controlsEnabled)

      Set the value of the `controlsEnabled` property.

      Contents: Enable a set of buttons to control reordering of items within this list.Requires selection of determine items to adjust via buttons.

      Specified by:
        `setControlsEnabled` in interface `IList`

    - #### isControlsEnabled

          public java.lang.Boolean isControlsEnabled()

      Return the value of the `controlsEnabled` property.

      Contents: Enable a set of buttons to control reordering of items within this list.Requires selection of determine items to adjust via buttons. Default = 'false'.

      Specified by:
        `isControlsEnabled` in interface `IList`

    - #### setControlsFormat

          public void setControlsFormat(java.lang.String controlsFormat)

      Set the value of the `controlsFormat` property.

      Contents: Defines the order in which the reordering buttons render. Specify a space delimited list of values such as "top", "up", "dwn", "btm".

      Specified by:
        `setControlsFormat` in interface `IList`

    - #### getControlsFormat

          public java.lang.String getControlsFormat()

      Return the value of the `controlsFormat` property.

      Contents: Defines the order in which the reordering buttons render. Specify a space delimited list of values such as "top", "up", "dwn", "btm". Default = 'top up dwn btm'.

      Specified by:
        `getControlsFormat` in interface `IList`

    - #### setControlsItemClass

          public void setControlsItemClass(java.lang.String controlsItemClass)

      Set the value of the `controlsItemClass` property.

      Contents: Style class to apply to the div surrounding the individual reordering icons.

      Specified by:
        `setControlsItemClass` in interface `IList`

    - #### getControlsItemClass

          public java.lang.String getControlsItemClass()

      Return the value of the `controlsItemClass` property.

      Contents: Style class to apply to the div surrounding the individual reordering icons. Default = 'ui-state-default ui-corner-all'.

      Specified by:
        `getControlsItemClass` in interface `IList`

    - #### setControlsSpacerClass

          public void setControlsSpacerClass(java.lang.String controlsSpacerClass)

      Set the value of the `controlsSpacerClass` property.

      Contents: Style class to apply to the spacer container around each button element.

      Specified by:
        `setControlsSpacerClass` in interface `IList`

    - #### getControlsSpacerClass

          public java.lang.String getControlsSpacerClass()

      Return the value of the `controlsSpacerClass` property.

      Contents: Style class to apply to the spacer container around each button element.

      Specified by:
        `getControlsSpacerClass` in interface `IList`

    - #### setDoubleClickMigration

          public void setDoubleClickMigration(java.lang.Boolean doubleClickMigration)

      Set the value of the `doubleClickMigration` property.

      Contents: Enable single item migration to the next list in the first matching ListControl via item double clicks; with reverse migation via shift double clicks. If used in a dual list configuration the reverse migration is implied for the second list, and holding the shift key isn't required. Note this attribute has no effect when an f:selectItem(s) model is used.

      Specified by:
        `setDoubleClickMigration` in interface `IList`

    - #### isDoubleClickMigration

          public java.lang.Boolean isDoubleClickMigration()

      Return the value of the `doubleClickMigration` property.

      Contents: Enable single item migration to the next list in the first matching ListControl via item double clicks; with reverse migation via shift double clicks. If used in a dual list configuration the reverse migration is implied for the second list, and holding the shift key isn't required. Note this attribute has no effect when an f:selectItem(s) model is used. Default = 'true'.

      Specified by:
        `isDoubleClickMigration` in interface `IList`

    - #### setDownButtonClass

          public void setDownButtonClass(java.lang.String downButtonClass)

      Set the value of the `downButtonClass` property.

      Contents: Style class to apply to the span defining the down button icon.

      Specified by:
        `setDownButtonClass` in interface `IList`

    - #### getDownButtonClass

          public java.lang.String getDownButtonClass()

      Return the value of the `downButtonClass` property.

      Contents: Style class to apply to the span defining the down button icon. Default = 'ui-icon ui-icon-arrow-1-s'.

      Specified by:
        `getDownButtonClass` in interface `IList`

    - #### setDragging

          public void setDragging(java.lang.Boolean dragging)

      Set the value of the `dragging` property.

      Contents: Enable the dragging of list items in this list. Note this attribute has no effect when an f:selectItem(s) model is used.

      Specified by:
        `setDragging` in interface `IList`

    - #### isDragging

          public java.lang.Boolean isDragging()

      Return the value of the `dragging` property.

      Contents: Enable the dragging of list items in this list. Note this attribute has no effect when an f:selectItem(s) model is used. Default = 'true'.

      Specified by:
        `isDragging` in interface `IList`

    - #### setDropGroup

          public void setDropGroup(java.lang.String dropGroup)

      Set the value of the `dropGroup` property.

      Contents: Enables inter-list dragging and dropping; an identifier used to link this region and others for bi-directional dropping. Note this attribute has no effect when an f:selectItem(s) model is used.

      Specified by:
        `setDropGroup` in interface `IList`

    - #### getDropGroup

          public java.lang.String getDropGroup()

      Return the value of the `dropGroup` property.

      Contents: Enables inter-list dragging and dropping; an identifier used to link this region and others for bi-directional dropping. Note this attribute has no effect when an f:selectItem(s) model is used.

      Specified by:
        `getDropGroup` in interface `IList`

    - #### setFilterBy

          public void setFilterBy(java.lang.Object filterBy)

      Set the value of the `filterBy` property.

      Contents: Defines a ValueExpression of the value of this row to use when filtering this list. Setting this attribute enables filtering.

      Specified by:
        `setFilterBy` in interface `IList`

    - #### getFilterBy

          public java.lang.Object getFilterBy()

      Return the value of the `filterBy` property.

      Contents: Defines a ValueExpression of the value of this row to use when filtering this list. Setting this attribute enables filtering.

      Specified by:
        `getFilterBy` in interface `IList`

    - #### setFilterEvent

          public void setFilterEvent(java.lang.String filterEvent)

      Set the value of the `filterEvent` property.

      Contents: Defines the Javascript event on which to trigger filter event, ex. 'keyup', 'blur', 'change' and 'enter' (Note: columns filtered based on Date values always trigger the event on change).

      Specified by:
        `setFilterEvent` in interface `IList`

    - #### getFilterEvent

          public java.lang.String getFilterEvent()

      Return the value of the `filterEvent` property.

      Contents: Defines the Javascript event on which to trigger filter event, ex. 'keyup', 'blur', 'change' and 'enter' (Note: columns filtered based on Date values always trigger the event on change). Default = 'change'.

      Specified by:
        `getFilterEvent` in interface `IList`

    - #### setFilterMatchMode

          public void setFilterMatchMode(java.lang.String filterMatchMode)

      Set the value of the `filterMatchMode` property.

      Contents: Defines the method of filter comparison used, default is "startsWith". Types available include: "contains", "exact", "startsWith" and "endsWith".

      Specified by:
        `setFilterMatchMode` in interface `IList`

    - #### getFilterMatchMode

          public java.lang.String getFilterMatchMode()

      Return the value of the `filterMatchMode` property.

      Contents: Defines the method of filter comparison used, default is "startsWith". Types available include: "contains", "exact", "startsWith" and "endsWith". Default = 'startsWith'.

      Specified by:
        `getFilterMatchMode` in interface `IList`

    - #### setFilterOptions

          public void setFilterOptions(java.lang.Object filterOptions)

      Set the value of the `filterOptions` property.

      Contents: Defines a collection of SelectItem objects for use as filter choices.

      Specified by:
        `setFilterOptions` in interface `IList`

    - #### getFilterOptions

          public java.lang.Object getFilterOptions()

      Return the value of the `filterOptions` property.

      Contents: Defines a collection of SelectItem objects for use as filter choices.

      Specified by:
        `getFilterOptions` in interface `IList`

    - #### setFilterStyle

          public void setFilterStyle(java.lang.String filterStyle)

      Set the value of the `filterStyle` property.

      Contents: Defines additional CSS rules to be applied to the filter text input.

      Specified by:
        `setFilterStyle` in interface `IList`

    - #### getFilterStyle

          public java.lang.String getFilterStyle()

      Return the value of the `filterStyle` property.

      Contents: Defines additional CSS rules to be applied to the filter text input.

      Specified by:
        `getFilterStyle` in interface `IList`

    - #### setFilterStyleClass

          public void setFilterStyleClass(java.lang.String filterStyleClass)

      Set the value of the `filterStyleClass` property.

      Contents: Defines supplementary CSS classes to add to those already applied on this component.

      Specified by:
        `setFilterStyleClass` in interface `IList`

    - #### getFilterStyleClass

          public java.lang.String getFilterStyleClass()

      Return the value of the `filterStyleClass` property.

      Contents: Defines supplementary CSS classes to add to those already applied on this component.

      Specified by:
        `getFilterStyleClass` in interface `IList`

    - #### setFilterValue

          public void setFilterValue(java.lang.String filterValue)

      Set the value of the `filterValue` property.

      Contents: Defines the string input filtering this column, coming from the client, or from the application via a value binding.

      Specified by:
        `setFilterValue` in interface `IList`

    - #### getFilterValue

          public java.lang.String getFilterValue()

      Return the value of the `filterValue` property.

      Contents: Defines the string input filtering this column, coming from the client, or from the application via a value binding.

      Specified by:
        `getFilterValue` in interface `IList`

    - #### setFilterValues

          public void setFilterValues(java.lang.Object filterValues)

      Set the value of the `filterValues` property.

      Contents: Defines multiple filter values. This property can only be set programmatically, typically when using the filter facet as well. The value must be a Collection or an Array of strings. If this attribute is set, 'filterValue', 'filterValueMin', and 'filterValueMax' are ignored.

      Specified by:
        `setFilterValues` in interface `IList`

    - #### getFilterValues

          public java.lang.Object getFilterValues()

      Return the value of the `filterValues` property.

      Contents: Defines multiple filter values. This property can only be set programmatically, typically when using the filter facet as well. The value must be a Collection or an Array of strings. If this attribute is set, 'filterValue', 'filterValueMin', and 'filterValueMax' are ignored.

      Specified by:
        `getFilterValues` in interface `IList`

    - #### setFooterClass

          public void setFooterClass(java.lang.String footerClass)

      Set the value of the `footerClass` property.

      Contents: Style class to apply to the footer DIV element.

      Specified by:
        `setFooterClass` in interface `IList`
      Overrides:
        `setFooterClass` in class `javax.faces.component.html.HtmlDataTable`

    - #### getFooterClass

          public java.lang.String getFooterClass()

      Return the value of the `footerClass` property.

      Contents: Style class to apply to the footer DIV element.

      Specified by:
        `getFooterClass` in interface `IList`
      Overrides:
        `getFooterClass` in class `javax.faces.component.html.HtmlDataTable`

    - #### setFooterStyle

          public void setFooterStyle(java.lang.String footerStyle)

      Set the value of the `footerStyle` property.

      Contents: Style rules to apply to the footer DIV element.

      Specified by:
        `setFooterStyle` in interface `IList`

    - #### getFooterStyle

          public java.lang.String getFooterStyle()

      Return the value of the `footerStyle` property.

      Contents: Style rules to apply to the footer DIV element.

      Specified by:
        `getFooterStyle` in interface `IList`

    - #### setHeaderClass

          public void setHeaderClass(java.lang.String headerClass)

      Set the value of the `headerClass` property.

      Contents: Style class to apply to the header DIV element.

      Specified by:
        `setHeaderClass` in interface `IList`
      Overrides:
        `setHeaderClass` in class `javax.faces.component.html.HtmlDataTable`

    - #### getHeaderClass

          public java.lang.String getHeaderClass()

      Return the value of the `headerClass` property.

      Contents: Style class to apply to the header DIV element.

      Specified by:
        `getHeaderClass` in interface `IList`
      Overrides:
        `getHeaderClass` in class `javax.faces.component.html.HtmlDataTable`

    - #### setHeaderStyle

          public void setHeaderStyle(java.lang.String headerStyle)

      Set the value of the `headerStyle` property.

      Contents: Style rules to apply to the header DIV element.

      Specified by:
        `setHeaderStyle` in interface `IList`

    - #### getHeaderStyle

          public java.lang.String getHeaderStyle()

      Return the value of the `headerStyle` property.

      Contents: Style rules to apply to the header DIV element.

      Specified by:
        `getHeaderStyle` in interface `IList`

    - #### setHeight

          public void setHeight(java.lang.String height)

      Set the value of the `height` property.

      Contents: Defines a CSS height value to set in the UL element style. eg. '200px', '10%', etc.

      Specified by:
        `setHeight` in interface `IList`

    - #### getHeight

          public java.lang.String getHeight()

      Return the value of the `height` property.

      Contents: Defines a CSS height value to set in the UL element style. eg. '200px', '10%', etc.

      Specified by:
        `getHeight` in interface `IList`

    - #### setItemClass

          public void setItemClass(java.lang.String itemClass)

      Set the value of the `itemClass` property.

      Contents: Style class to apply to the iterative LI element.

      Specified by:
        `setItemClass` in interface `IList`

    - #### getItemClass

          public java.lang.String getItemClass()

      Return the value of the `itemClass` property.

      Contents: Style class to apply to the iterative LI element.

      Specified by:
        `getItemClass` in interface `IList`

    - #### setItemStyle

          public void setItemStyle(java.lang.String itemStyle)

      Set the value of the `itemStyle` property.

      Contents: Style rules to apply to the iterative LI element.

      Specified by:
        `setItemStyle` in interface `IList`

    - #### getItemStyle

          public java.lang.String getItemStyle()

      Return the value of the `itemStyle` property.

      Contents: Style rules to apply to the iterative LI element.

      Specified by:
        `getItemStyle` in interface `IList`

    - #### setPlaceholder

          public void setPlaceholder(java.lang.Boolean placeholder)

      Set the value of the `placeholder` property.

      Contents: Enable adding a style to the whitespace that is cleared for a list item being dragged / dropped.

      Specified by:
        `setPlaceholder` in interface `IList`

    - #### isPlaceholder

          public java.lang.Boolean isPlaceholder()

      Return the value of the `placeholder` property.

      Contents: Enable adding a style to the whitespace that is cleared for a list item being dragged / dropped. Default = 'true'.

      Specified by:
        `isPlaceholder` in interface `IList`

    - #### setPlaceholderClass

          public void setPlaceholderClass(java.lang.String placeholderClass)

      Set the value of the `placeholderClass` property.

      Contents: Style class to apply to the optional dragging placeholder LI element.

      Specified by:
        `setPlaceholderClass` in interface `IList`

    - #### getPlaceholderClass

          public java.lang.String getPlaceholderClass()

      Return the value of the `placeholderClass` property.

      Contents: Style class to apply to the optional dragging placeholder LI element.

      Specified by:
        `getPlaceholderClass` in interface `IList`

    - #### setSelectionListener

          public void setSelectionListener(javax.el.MethodExpression selectionListener)

      Set the value of the `selectionListener` property.

      Contents: Define a method listener that is passed a ListSelectEvent wrapping the arrayof items newly selected in a single request.

      Specified by:
        `setSelectionListener` in interface `IList`

    - #### getSelectionListener

          public javax.el.MethodExpression getSelectionListener()

      Return the value of the `selectionListener` property.

      Contents: Define a method listener that is passed a ListSelectEvent wrapping the arrayof items newly selected in a single request.

      Specified by:
        `getSelectionListener` in interface `IList`

    - #### setSelectionMode

          public void setSelectionMode(java.lang.String selectionMode)

      Set the value of the `selectionMode` property.

      Contents: Enables item selection via clicking when defined as "multiple" or "single". The default value of the property is null; this and any value other than "multiple" or "single" disables selection for the list. Note that each click begins a new selection. If "multiple" is set, CTRL (or Command) + Click adds to (or removes from) the selection, and Shift + Click will add to the selection all unselected items between the previous selection (or deselection) and the clicked item (inclusive of the clicked item itself).

      Specified by:
        `setSelectionMode` in interface `IList`

    - #### getSelectionMode

          public java.lang.String getSelectionMode()

      Return the value of the `selectionMode` property.

      Contents: Enables item selection via clicking when defined as "multiple" or "single". The default value of the property is null; this and any value other than "multiple" or "single" disables selection for the list. Note that each click begins a new selection. If "multiple" is set, CTRL (or Command) + Click adds to (or removes from) the selection, and Shift + Click will add to the selection all unselected items between the previous selection (or deselection) and the clicked item (inclusive of the clicked item itself).

      Specified by:
        `getSelectionMode` in interface `IList`

    - #### setSelections

          public void setSelections(java.util.Set selections)

      Set the value of the `selections` property.

      Contents: Defines the set of Objects from the source List that are selected. Note that when f:selectItem(s) children are used as the model to this ace:list that selections are instead added to the Collection bound to the value attribute, to more closely emulate the h:selectManyListbox component.

      Specified by:
        `setSelections` in interface `IList`

    - #### getSelections

          public java.util.Set getSelections()

      Return the value of the `selections` property.

      Contents: Defines the set of Objects from the source List that are selected. Note that when f:selectItem(s) children are used as the model to this ace:list that selections are instead added to the Collection bound to the value attribute, to more closely emulate the h:selectManyListbox component.

      Specified by:
        `getSelections` in interface `IList`

    - #### setSortAscending

          public void setSortAscending(java.lang.Boolean sortAscending)

      Set the value of the `sortAscending` property.

      Contents: Defines the direction of column values during sorting. The column directions incoming from the client during a sort request overwrite any set by the application. Processing the sorted columns is done by the component whenever a client edits a sort control or the application calls table.applySorting().

      Specified by:
        `setSortAscending` in interface `IList`

    - #### isSortAscending

          public java.lang.Boolean isSortAscending()

      Return the value of the `sortAscending` property.

      Contents: Defines the direction of column values during sorting. The column directions incoming from the client during a sort request overwrite any set by the application. Processing the sorted columns is done by the component whenever a client edits a sort control or the application calls table.applySorting(). Default = 'false'.

      Specified by:
        `isSortAscending` in interface `IList`

    - #### setSortBy

          public void setSortBy(java.lang.Object sortBy)

      Set the value of the `sortBy` property.

      Contents: Defines a value expression representing the value of this column per row when sorting. Setting this attribute, or the "value" attribute for a column enables sorting.

      Specified by:
        `setSortBy` in interface `IList`

    - #### getSortBy

          public java.lang.Object getSortBy()

      Return the value of the `sortBy` property.

      Contents: Defines a value expression representing the value of this column per row when sorting. Setting this attribute, or the "value" attribute for a column enables sorting.

      Specified by:
        `getSortBy` in interface `IList`

    - #### setSortFunction

          public void setSortFunction(java.util.Comparator sortFunction)

      Set the value of the `sortFunction` property.

      Contents: Defines an alternate method of sorting. Sort this column using a Comparator

      Specified by:
        `setSortFunction` in interface `IList`

    - #### getSortFunction

          public java.util.Comparator getSortFunction()

      Return the value of the `sortFunction` property.

      Contents: Defines an alternate method of sorting. Sort this column using a Comparator

      Specified by:
        `getSortFunction` in interface `IList`

    - #### setStyle

          public void setStyle(java.lang.String style)

      Set the value of the `style` property.

      Contents: Style rules to apply to the container DIV element

      Specified by:
        `setStyle` in interface `IList`
      Overrides:
        `setStyle` in class `javax.faces.component.html.HtmlDataTable`

    - #### getStyle

          public java.lang.String getStyle()

      Return the value of the `style` property.

      Contents: Style rules to apply to the container DIV element

      Specified by:
        `getStyle` in interface `IList`
      Overrides:
        `getStyle` in class `javax.faces.component.html.HtmlDataTable`

    - #### setStyleClass

          public void setStyleClass(java.lang.String styleClass)

      Set the value of the `styleClass` property.

      Contents: Style class to apply to the container DIV element.

      Specified by:
        `setStyleClass` in interface `IList`
      Overrides:
        `setStyleClass` in class `javax.faces.component.html.HtmlDataTable`

    - #### getStyleClass

          public java.lang.String getStyleClass()

      Return the value of the `styleClass` property.

      Contents: Style class to apply to the container DIV element.

      Specified by:
        `getStyleClass` in interface `IList`
      Overrides:
        `getStyleClass` in class `javax.faces.component.html.HtmlDataTable`

    - #### setTabIndex

          public void setTabIndex(java.lang.Integer tabIndex)

      Set the value of the `tabIndex` property.

      Contents: Defines a tabindex to be shared by all keyboard navigable elements of the table. This includes sort controls, filter fields and individual rows themselves.

      Specified by:
        `setTabIndex` in interface `IList`

    - #### getTabIndex

          public java.lang.Integer getTabIndex()

      Return the value of the `tabIndex` property.

      Contents: Defines a tabindex to be shared by all keyboard navigable elements of the table. This includes sort controls, filter fields and individual rows themselves. Default = '0'.

      Specified by:
        `getTabIndex` in interface `IList`

    - #### setTopButtonClass

          public void setTopButtonClass(java.lang.String topButtonClass)

      Set the value of the `topButtonClass` property.

      Contents: Style class to apply to the span defining the top button icon.

      Specified by:
        `setTopButtonClass` in interface `IList`

    - #### getTopButtonClass

          public java.lang.String getTopButtonClass()

      Return the value of the `topButtonClass` property.

      Contents: Style class to apply to the span defining the top button icon. Default = 'ui-icon ui-icon-arrowstop-1-n'.

      Specified by:
        `getTopButtonClass` in interface `IList`

    - #### setUpButtonClass

          public void setUpButtonClass(java.lang.String upButtonClass)

      Set the value of the `upButtonClass` property.

      Contents: Style class to apply to the span defining the up button icon.

      Specified by:
        `setUpButtonClass` in interface `IList`

    - #### getUpButtonClass

          public java.lang.String getUpButtonClass()

      Return the value of the `upButtonClass` property.

      Contents: Style class to apply to the span defining the up button icon. Default = 'ui-icon ui-icon-arrow-1-n'.

      Specified by:
        `getUpButtonClass` in interface `IList`

    - #### setFilterFacet

          public void setFilterFacet(javax.faces.component.UIComponent filter)

      Set the value of the `filter facet` property.

    - #### getFilterFacet

          public javax.faces.component.UIComponent getFilterFacet()

      Return the value of the `filter facet` property.

    - #### setFooterFacet

          public void setFooterFacet(javax.faces.component.UIComponent footer)

      Set the value of the `footer facet` property.

    - #### getFooterFacet

          public javax.faces.component.UIComponent getFooterFacet()

      Return the value of the `footer facet` property.

    - #### setHeaderFacet

          public void setHeaderFacet(javax.faces.component.UIComponent header)

      Set the value of the `header facet` property.

    - #### getHeaderFacet

          public javax.faces.component.UIComponent getHeaderFacet()

      Return the value of the `header facet` property.

    - #### setApplyingFilters

          public void setApplyingFilters(java.lang.Boolean applyingFilters)

      Set the value of the `applyingFilters` property.

      Specified by:
        `setApplyingFilters` in interface `IList`

    - #### isApplyingFilters

          public java.lang.Boolean isApplyingFilters()

      Return the value of the `applyingFilters` property.

      Specified by:
        `isApplyingFilters` in interface `IList`

    - #### setApplyingSorts

          public void setApplyingSorts(java.lang.Boolean applyingSorts)

      Set the value of the `applyingSorts` property.

      Specified by:
        `setApplyingSorts` in interface `IList`

    - #### isApplyingSorts

          public java.lang.Boolean isApplyingSorts()

      Return the value of the `applyingSorts` property.

      Specified by:
        `isApplyingSorts` in interface `IList`

    - #### setFilteredData

          public void setFilteredData(java.util.List filteredData)

      Set the value of the `filteredData` property.

      Specified by:
        `setFilteredData` in interface `IList`

    - #### getFilteredData

          public java.util.List getFilteredData()

      Return the value of the `filteredData` property.

      Specified by:
        `getFilteredData` in interface `IList`

    - #### setValueHashCode

          public void setValueHashCode(java.lang.Integer valueHashCode)

      Set the value of the `valueHashCode` property.

      Specified by:
        `setValueHashCode` in interface `IList`

    - #### getValueHashCode

          public java.lang.Integer getValueHashCode()

      Return the value of the `valueHashCode` property.

      Specified by:
        `getValueHashCode` in interface `IList`

    - #### isPropertySet

          protected boolean isPropertySet(java.lang.String finder)

    - #### setValueExpression

          public void setValueExpression(java.lang.String name,
                                         javax.el.ValueExpression binding)

      Overrides:
        `setValueExpression` in class `javax.faces.component.UIData`

    - #### getEventNames

          public java.util.Collection<java.lang.String> getEventNames()

      Specified by:
        `getEventNames` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `getEventNames` in class `javax.faces.component.html.HtmlDataTable`

    - #### getDefaultEventName

          public java.lang.String getDefaultEventName()

      Specified by:
        `getDefaultEventName` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `getDefaultEventName` in class `javax.faces.component.html.HtmlDataTable`

    - #### getDefaultRender

          public java.lang.String getDefaultRender(java.lang.String event)

      Specified by:
        `getDefaultRender` in interface `IceClientBehaviorHolder`

    - #### getDefaultExecute

          public java.lang.String getDefaultExecute(java.lang.String event)

      Specified by:
        `getDefaultExecute` in interface `IceClientBehaviorHolder`

    - #### getListenerArgument

          public java.lang.String getListenerArgument(java.lang.String event)

      Specified by:
        `getListenerArgument` in interface `IceClientBehaviorHolder`

    - #### addClientBehavior

          public void addClientBehavior(java.lang.String eventName,
                                        javax.faces.component.behavior.ClientBehavior behavior)

      Specified by:
        `addClientBehavior` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `addClientBehavior` in class `javax.faces.component.UIComponentBase`

Copyright 2025 ICEsoft Technologies Canada, Corp. All Rights Reserved.